<tw_events_photo>
    <div class="popup popup-events-photo">
        <div class="content-block" style="margin-top: 1em;">
			<div style="float:right"><a href="#" class="close-popup"><i class="fa fa-angle-down 2x" aria-hidden="true"></i></a></div>
            <div class="content-block-title" style="margin-bottom: 0;"></div>
            <div id="cropArea" align="center"></div>
            <p><a id="submitUploadImgBtn" onclick={submitUploadImg} class="button">上傳</a></p>
        </div>
    </div>
    <script>
        var tag = this;
        tag.uploadImg = null;
        tag.on('mount', function(){
            console.log("moount");
            tag.rotateImage(opts.file);
            App.popup('.popup-events-photo');
        });
        tag.rotateImage = function(file){
            EXIF.getData(file,function(){
                var orientation = EXIF.getTag(this,"Orientation");
                var can = document.createElement("canvas");
                var ctx = can.getContext('2d');
                var thisImage = new Image;
                thisImage.onload = function() {
                    // that.value = '';
                    opts.inputSource.value = '';
                    can.width  = thisImage.width;
                    can.height = thisImage.height;
                    
                    ctx.save();
                    var width  = can.width;  var styleWidth  = can.style.width;
                    var height = can.height; var styleHeight = can.style.height;
                    if (orientation) {
                        console.log(orientation);
                        if (orientation > 4) {
                           can.width  = height; can.style.width  = styleHeight;
                           can.height = width;  can.style.height = styleWidth;
                        }
                        switch (orientation) {
                            case 2: ctx.translate(width, 0);     ctx.scale(-1,1); break;
                            case 3: ctx.translate(width,height); ctx.rotate(Math.PI); break;
                            case 4: ctx.translate(0,height);     ctx.scale(1,-1); break;
                            case 5: ctx.rotate(0.5 * Math.PI);   ctx.scale(1,-1); break;
                            case 6: ctx.rotate(0.5 * Math.PI);   ctx.translate(0,-height); break;
                            case 7: ctx.rotate(0.5 * Math.PI);   ctx.translate(width,-height); ctx.scale(-1,1); break;
                            case 8: ctx.rotate(-0.5 * Math.PI);  ctx.translate(-width,0); break;
                        }
                    }
                    ctx.drawImage(thisImage,0,0);
                    ctx.restore();
                    
                    var rotatedImg = document.createElement("img");
                    rotatedImg.id = 'rotatedImg';
                    rotatedImg.src = can.toDataURL();
                    rotatedImg.onload = function(){
                        tag.resizeCanvasImage(this, can, 500, 500);
                        tag.cropAvatar(can.toDataURL());
                    }
                }
                thisImage.src = URL.createObjectURL(file);
                // tag.update();
            });
        }
        tag.cropAvatar = function(img){
        	console.log('crop');
        	$('#cropArea').html('<img id="cropAvatar" class=" wrapper" /><h3>請框選您的圖像</h3>');
        	$('#cropAvatar').attr('src', img);
        	setTimeout(function(){
        	    $('#cropAvatar').Jcrop({
            		onSelect: tag.cropAsAvatar,
            		aspectRatio: 1
            	});
            // 	tag.update();
        	},100);
        	
        // 	tag.update();
        }
        
        tag.resizeImg = function (img, MAX_WIDTH, MAX_HEIGHT){
        	var canvas = document.createElement("canvas");
        	var ctx = canvas.getContext("2d");
        	ctx.drawImage(img, 0, 0);
        
        	var width = img.width;
        	var height = img.height;
        
        	if (width > height) {
        		if (width > MAX_WIDTH) {
        			height *= MAX_WIDTH / width;
        			width = MAX_WIDTH;
        		}
        	} else {
        		if (height > MAX_HEIGHT) {
        			width *= MAX_HEIGHT / height;
        			height = MAX_HEIGHT;
        		}
        	}
        	canvas.width = width;
        	canvas.height = height;
        	var ctx = canvas.getContext("2d");
        	ctx.drawImage(img, 0, 0, width, height);
        	var dataUrl = canvas.toDataURL("image/png");
        	return dataUrl;
        }
        
        tag.cropAsAvatar = function (coords){
        	console.log(coords);
        	if(parseInt(coords.w) > 0) {
        		var img = document.getElementById('cropAvatar');
        		
        		var canvas = document.createElement("canvas");
        		canvas.width = 512;
        		canvas.height = 512;
        		
        		var ctx = canvas.getContext("2d");
        		
        		ctx.drawImage(img, coords.x, coords.y, coords.w, coords.h, 0, 0, canvas.width, canvas.height);
        		var dataUrl = canvas.toDataURL("image/png");
        		tag.uploadImg = dataUrl;
        	}
        }
        
        tag.resizeCanvasImage = function (img, canvas, maxWidth, maxHeight) {
            var imgWidth = img.width, 
                imgHeight = img.height;
        
            var ratio = 1, ratio1 = 1, ratio2 = 1;
            ratio1 = maxWidth / imgWidth;
            ratio2 = maxHeight / imgHeight;
        
            // Use the smallest ratio that the image best fit into the maxWidth x maxHeight box.
            if (ratio1 < ratio2) {
                ratio = ratio1;
            }
            else {
                ratio = ratio2;
            }
        
            var canvasContext = canvas.getContext("2d");
            var canvasCopy = document.createElement("canvas");
            var copyContext = canvasCopy.getContext("2d");
            var canvasCopy2 = document.createElement("canvas");
            var copyContext2 = canvasCopy2.getContext("2d");
            canvasCopy.width = imgWidth;
            canvasCopy.height = imgHeight;  
            copyContext.drawImage(img, 0, 0);
        
            // init
            canvasCopy2.width = imgWidth;
            canvasCopy2.height = imgHeight;        
            copyContext2.drawImage(canvasCopy, 0, 0, canvasCopy.width, canvasCopy.height, 0, 0, canvasCopy2.width, canvasCopy2.height);
        
        
            var rounds = 2;
            var roundRatio = ratio * rounds;
            for (var i = 1; i <= rounds; i++) {
                console.log("Step: "+i);
        
                // tmp
                canvasCopy.width = imgWidth * roundRatio / i;
                canvasCopy.height = imgHeight * roundRatio / i;
        
                copyContext.drawImage(canvasCopy2, 0, 0, canvasCopy2.width, canvasCopy2.height, 0, 0, canvasCopy.width, canvasCopy.height);
        
                // copy back
                canvasCopy2.width = imgWidth * roundRatio / i;
                canvasCopy2.height = imgHeight * roundRatio / i;
                copyContext2.drawImage(canvasCopy, 0, 0, canvasCopy.width, canvasCopy.height, 0, 0, canvasCopy2.width, canvasCopy2.height);
        
            } // end for
        
        
            // copy back to canvas
            canvas.width = imgWidth * roundRatio / rounds;
            canvas.height = imgHeight * roundRatio / rounds;
            canvasContext.drawImage(canvasCopy2, 0, 0, canvasCopy2.width, canvasCopy2.height, 0, 0, canvas.width, canvas.height);
        }
        tag.submitUploadImg = function(){
            // console.log('submitUploadImg');
            App.showIndicator();
            $.ajax({
                "method": 'POST',
                "url": API_ENDPOINT+"/employee/event/photos/"+opts.event.id_events,
                "data": {
                    img: tag.uploadImg
                },
                "success": function(data){
                    App.hideIndicator();
                    App.closeModal();
                    App.alert("檔案儲存成功", "SUCCESS");
                    tagRegister.tw_events_maintain.loadEventPhotos();
                    // tagRegister.tw_cmp.loadCmp("tw_events_content", {"event": data[0]});
                }
            });
        }
    </script>
</tw_events_photo>